/* gcalc-parser.c generated by valac 0.54.4, the Vala compiler
 * generated from gcalc-parser.vala, do not modify */

/* gcalc-gexpresion.vala
 *
 * Copyright (C) 2018  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gcalc/gcalc.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <errno.h>
#include "gcalc.h"

enum  {
	GCALC_PARSER_0_PROPERTY,
	GCALC_PARSER_NUM_PROPERTIES
};
static GParamSpec* gcalc_parser_properties[GCALC_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_scanner_destroy0(var) ((var == NULL) ? NULL : (var = (g_scanner_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GCalcParserPrivate {
	GCalcMathExpression* current;
	GCalcMathExpression* current_parent;
	GCalcMathExpression* top_parent;
	GCalcEquation* eq;
	GRegex* rg;
	gboolean enable_parameter;
	GeeArrayList* expected;
	GScanner* scanner;
};

static gint GCalcParser_private_offset;
static gpointer gcalc_parser_parent_class = NULL;

static void gcalc_parser_add_constant (GCalcParser* self,
                                GCalcMathConstant* c);
VALA_EXTERN GCalcVariable* gcalc_variable_new (const gchar* name);
VALA_EXTERN GCalcVariable* gcalc_variable_construct (GType object_type,
                                         const gchar* name);
static void gcalc_parser_process_term_operator (GCalcParser* self,
                                         GCalcMathOperator* op,
                                         GCalcEquation* eq,
                                         GError** error);
static void gcalc_parser_process_operator (GCalcParser* self,
                                    GCalcMathOperator* opp,
                                    GCalcEquation* eq,
                                    GError** error);
static GObject * gcalc_parser_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void gcalc_parser_finalize (GObject * obj);
static GType gcalc_parser_get_type_once (void);

static inline gpointer
gcalc_parser_get_instance_private (GCalcParser* self)
{
	return G_STRUCT_MEMBER_P (self, GCalcParser_private_offset);
}

static GType
gcalc_parser_token_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GCALC_PARSER_TOKEN_TYPE_NONE, "GCALC_PARSER_TOKEN_TYPE_NONE", "none"}, {GCALC_PARSER_TOKEN_TYPE_EOF, "GCALC_PARSER_TOKEN_TYPE_EOF", "eof"}, {GCALC_PARSER_TOKEN_TYPE_IDENTIFIER, "GCALC_PARSER_TOKEN_TYPE_IDENTIFIER", "identifier"}, {GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL, "GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL", "integer-literal"}, {GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL, "GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL", "real-literal"}, {GCALC_PARSER_TOKEN_TYPE_STAR, "GCALC_PARSER_TOKEN_TYPE_STAR", "star"}, {GCALC_PARSER_TOKEN_TYPE_PLUS, "GCALC_PARSER_TOKEN_TYPE_PLUS", "plus"}, {GCALC_PARSER_TOKEN_TYPE_DIV, "GCALC_PARSER_TOKEN_TYPE_DIV", "div"}, {GCALC_PARSER_TOKEN_TYPE_MINUS, "GCALC_PARSER_TOKEN_TYPE_MINUS", "minus"}, {GCALC_PARSER_TOKEN_TYPE_ASSIGN, "GCALC_PARSER_TOKEN_TYPE_ASSIGN", "assign"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS, "GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS", "open-parens"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS, "GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS", "close-parens"}, {GCALC_PARSER_TOKEN_TYPE_CARRET, "GCALC_PARSER_TOKEN_TYPE_CARRET", "carret"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE, "GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE", "close-brace"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET, "GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET", "close-bracket"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE, "GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE", "open-brace"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET, "GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET", "open-bracket"}, {GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL, "GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL", "string-literal"}, {GCALC_PARSER_TOKEN_TYPE_OP_AND, "GCALC_PARSER_TOKEN_TYPE_OP_AND", "op-and"}, {GCALC_PARSER_TOKEN_TYPE_OP_COALESCING, "GCALC_PARSER_TOKEN_TYPE_OP_COALESCING", "op-coalescing"}, {GCALC_PARSER_TOKEN_TYPE_OP_DEC, "GCALC_PARSER_TOKEN_TYPE_OP_DEC", "op-dec"}, {GCALC_PARSER_TOKEN_TYPE_OP_EQ, "GCALC_PARSER_TOKEN_TYPE_OP_EQ", "op-eq"}, {GCALC_PARSER_TOKEN_TYPE_OP_GE, "GCALC_PARSER_TOKEN_TYPE_OP_GE", "op-ge"}, {GCALC_PARSER_TOKEN_TYPE_OP_GT, "GCALC_PARSER_TOKEN_TYPE_OP_GT", "op-gt"}, {GCALC_PARSER_TOKEN_TYPE_OP_INC, "GCALC_PARSER_TOKEN_TYPE_OP_INC", "op-inc"}, {GCALC_PARSER_TOKEN_TYPE_OP_LE, "GCALC_PARSER_TOKEN_TYPE_OP_LE", "op-le"}, {GCALC_PARSER_TOKEN_TYPE_OP_LT, "GCALC_PARSER_TOKEN_TYPE_OP_LT", "op-lt"}, {GCALC_PARSER_TOKEN_TYPE_OP_NE, "GCALC_PARSER_TOKEN_TYPE_OP_NE", "op-ne"}, {GCALC_PARSER_TOKEN_TYPE_OP_NEG, "GCALC_PARSER_TOKEN_TYPE_OP_NEG", "op-neg"}, {GCALC_PARSER_TOKEN_TYPE_OP_OR, "GCALC_PARSER_TOKEN_TYPE_OP_OR", "op-or"}, {GCALC_PARSER_TOKEN_TYPE_OP_PTR, "GCALC_PARSER_TOKEN_TYPE_OP_PTR", "op-ptr"}, {GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT, "GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT", "op-shift-left"}, {GCALC_PARSER_TOKEN_TYPE_SEMICOLON, "GCALC_PARSER_TOKEN_TYPE_SEMICOLON", "semicolon"}, {GCALC_PARSER_TOKEN_TYPE_TILDE, "GCALC_PARSER_TOKEN_TYPE_TILDE", "tilde"}, {GCALC_PARSER_TOKEN_TYPE_COLON, "GCALC_PARSER_TOKEN_TYPE_COLON", "colon"}, {GCALC_PARSER_TOKEN_TYPE_COMMA, "GCALC_PARSER_TOKEN_TYPE_COMMA", "comma"}, {GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON, "GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON", "double-colon"}, {GCALC_PARSER_TOKEN_TYPE_DOT, "GCALC_PARSER_TOKEN_TYPE_DOT", "dot"}, {GCALC_PARSER_TOKEN_TYPE_ELLIPSIS, "GCALC_PARSER_TOKEN_TYPE_ELLIPSIS", "ellipsis"}, {GCALC_PARSER_TOKEN_TYPE_INTERR, "GCALC_PARSER_TOKEN_TYPE_INTERR", "interr"}, {GCALC_PARSER_TOKEN_TYPE_HASH, "GCALC_PARSER_TOKEN_TYPE_HASH", "hash"}, {GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL, "GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL", "currency-symbol"}, {0, NULL, NULL}};
	GType gcalc_parser_token_type_type_id;
	gcalc_parser_token_type_type_id = g_enum_register_static ("GCalcParserTokenType", values);
	return gcalc_parser_token_type_type_id;
}

GType
gcalc_parser_token_type_get_type (void)
{
	static volatile gsize gcalc_parser_token_type_type_id__volatile = 0;
	if (g_once_init_enter (&gcalc_parser_token_type_type_id__volatile)) {
		GType gcalc_parser_token_type_type_id;
		gcalc_parser_token_type_type_id = gcalc_parser_token_type_get_type_once ();
		g_once_init_leave (&gcalc_parser_token_type_type_id__volatile, gcalc_parser_token_type_type_id);
	}
	return gcalc_parser_token_type_type_id__volatile;
}

/**
   * Creates a {@link MathEquation} and adds it to given
   * {@link MathEquationManager} including all Variables and
   * parameters found in the parser expression.
   */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar** unparsed)
{
	gdouble _vala__result_ = 0.0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	errno = 0;
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
	endptr = _tmp0_;
	_vala__result_ = _tmp1_;
	_tmp2_ = endptr;
	_tmp3_ = strlen (str);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
		_vala_unparsed = "";
		result = errno != ERANGE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	} else {
		gchar* _tmp5_;
		_tmp5_ = endptr;
		_vala_unparsed = (const gchar*) _tmp5_;
		result = FALSE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	}
}

void
gcalc_parser_parse (GCalcParser* self,
                    const gchar* str,
                    GCalcMathEquationManager* eqman,
                    GError** error)
{
	GCalcParserTokenType token = 0;
	GCalcEquation* _tmp0_;
	GScanner* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GCalcExpressionContainer* _tmp372_;
	GCalcExpressionContainer* _tmp373_;
	GCalcEquation* _tmp374_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	g_return_if_fail (eqman != NULL);
	token = GCALC_PARSER_TOKEN_TYPE_NONE;
	_tmp0_ = gcalc_equation_new ();
	_g_object_unref0 (self->priv->eq);
	self->priv->eq = _tmp0_;
	_tmp1_ = self->priv->scanner;
	_tmp2_ = strlen (str);
	_tmp3_ = _tmp2_;
	g_scanner_input_text (_tmp1_, str, (guint) _tmp3_);
	_g_object_unref0 (self->priv->current);
	self->priv->current = NULL;
	_g_object_unref0 (self->priv->current_parent);
	self->priv->current_parent = NULL;
	_g_object_unref0 (self->priv->top_parent);
	self->priv->top_parent = NULL;
	self->priv->enable_parameter = FALSE;
	while (TRUE) {
		GCalcParserTokenType _tmp4_;
		GCalcParserTokenType _tmp5_;
		gchar* n = NULL;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		GCalcParserTokenType _tmp14_;
		_tmp4_ = token;
		if (!(_tmp4_ != GCALC_PARSER_TOKEN_TYPE_EOF)) {
			break;
		}
		token = gcalc_parser_read_token (self);
		_tmp5_ = token;
		if (_tmp5_ == GCALC_PARSER_TOKEN_TYPE_EOF) {
			break;
		}
		_tmp6_ = gcalc_parser_token_to_string (self);
		n = _tmp6_;
		_tmp8_ = self->priv->expected;
		_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ != 0) {
			GeeArrayList* _tmp11_;
			GCalcParserTokenType _tmp12_;
			_tmp11_ = self->priv->expected;
			_tmp12_ = token;
			_tmp7_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp11_, (gpointer) ((gintptr) _tmp12_));
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			GError* _tmp13_;
			_tmp13_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression"));
			_inner_error0_ = _tmp13_;
			g_propagate_error (error, _inner_error0_);
			_g_free0 (n);
			return;
		}
		_tmp14_ = token;
		switch (_tmp14_) {
			case GCALC_PARSER_TOKEN_TYPE_IDENTIFIER:
			{
				GRegex* _tmp15_;
				const gchar* _tmp16_;
				_tmp15_ = self->priv->rg;
				_tmp16_ = n;
				if (g_regex_match (_tmp15_, _tmp16_, G_REGEX_MATCH_ANCHORED, NULL)) {
					gchar* cxn = NULL;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gdouble v = 0.0;
					const gchar* _tmp19_;
					GCalcConstant* cx = NULL;
					GCalcConstant* _tmp20_;
					GCalcConstant* _tmp21_;
					_tmp17_ = n;
					_tmp18_ = string_replace (_tmp17_, "i", "");
					cxn = _tmp18_;
					_tmp19_ = cxn;
					v = double_parse (_tmp19_);
					_tmp20_ = gcalc_constant_new_complex ((gdouble) 0, v);
					cx = _tmp20_;
					_tmp21_ = cx;
					gcalc_parser_add_constant (self, (GCalcMathConstant*) _tmp21_);
					_g_object_unref0 (cx);
					_g_free0 (cxn);
				} else {
					GCalcMathExpression* sfunc = NULL;
					GCalcExpressionContainer* _tmp22_;
					GCalcExpressionContainer* _tmp23_;
					const gchar* _tmp24_;
					GCalcMathExpression* _tmp25_;
					GCalcMathExpression* _tmp26_;
					_tmp22_ = gcalc_math_equation_manager_get_functions (eqman);
					_tmp23_ = _tmp22_;
					_tmp24_ = n;
					_tmp25_ = gcalc_expression_container_find_named (_tmp23_, _tmp24_);
					sfunc = _tmp25_;
					_tmp26_ = sfunc;
					if (_tmp26_ != NULL) {
						GCalcMathExpression* _tmp27_;
						GObject* _tmp28_;
						GObject* _tmp29_;
						GCalcMathExpression* _tmp30_;
						GCalcMathExpression* _tmp31_;
						_tmp27_ = sfunc;
						_tmp28_ = g_object_new (G_TYPE_FROM_INSTANCE ((GObject*) _tmp27_), NULL);
						_tmp29_ = G_IS_INITIALLY_UNOWNED (_tmp28_) ? g_object_ref_sink (_tmp28_) : _tmp28_;
						_tmp30_ = GCALC_IS_MATH_EXPRESSION (_tmp29_) ? ((GCalcMathExpression*) _tmp29_) : NULL;
						if (_tmp30_ == NULL) {
							_g_object_unref0 (_tmp29_);
						}
						_g_object_unref0 (sfunc);
						sfunc = _tmp30_;
						_tmp31_ = self->priv->current;
						if (_tmp31_ == NULL) {
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp32_;
							GCalcEquation* _tmp33_;
							GCalcExpressionContainer* _tmp34_;
							GCalcExpressionContainer* _tmp35_;
							GCalcPolynomial* _tmp36_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp37_;
							GCalcPolynomial* _tmp38_;
							GCalcExpressionContainer* _tmp39_;
							GCalcExpressionContainer* _tmp40_;
							GCalcTerm* _tmp41_;
							GCalcTerm* _tmp42_;
							GCalcExpressionContainer* _tmp43_;
							GCalcExpressionContainer* _tmp44_;
							GCalcMathExpression* _tmp45_;
							GCalcMathExpression* _tmp46_;
							GCalcMathExpression* _tmp47_;
							GCalcTerm* _tmp48_;
							GCalcMathExpression* _tmp49_;
							GCalcPolynomial* _tmp50_;
							GCalcMathExpression* _tmp51_;
							GeeArrayList* _tmp52_;
							GeeArrayList* _tmp53_;
							_tmp32_ = gcalc_polynomial_new ();
							exp = _tmp32_;
							_tmp33_ = self->priv->eq;
							_tmp34_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp33_);
							_tmp35_ = _tmp34_;
							_tmp36_ = exp;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, (GCalcMathExpression*) _tmp36_);
							_tmp37_ = gcalc_term_new ();
							t = _tmp37_;
							_tmp38_ = exp;
							_tmp39_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp38_);
							_tmp40_ = _tmp39_;
							_tmp41_ = t;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, (GCalcMathExpression*) _tmp41_);
							_tmp42_ = t;
							_tmp43_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp42_);
							_tmp44_ = _tmp43_;
							_tmp45_ = sfunc;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, _tmp45_);
							_tmp46_ = sfunc;
							_tmp47_ = _g_object_ref0 (_tmp46_);
							_g_object_unref0 (self->priv->current);
							self->priv->current = _tmp47_;
							_tmp48_ = t;
							_tmp49_ = _g_object_ref0 ((GCalcMathExpression*) _tmp48_);
							_g_object_unref0 (self->priv->current_parent);
							self->priv->current_parent = _tmp49_;
							_tmp50_ = exp;
							_tmp51_ = _g_object_ref0 ((GCalcMathExpression*) _tmp50_);
							_g_object_unref0 (self->priv->top_parent);
							self->priv->top_parent = _tmp51_;
							_tmp52_ = self->priv->expected;
							gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp52_);
							_tmp53_ = self->priv->expected;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp53_, (gpointer) ((gintptr) GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS));
							_g_object_unref0 (t);
							_g_object_unref0 (exp);
						} else {
							gboolean _tmp54_ = FALSE;
							gboolean _tmp55_ = FALSE;
							GCalcMathExpression* _tmp56_;
							_tmp56_ = self->priv->current;
							if (GCALC_IS_MATH_OPERATOR (_tmp56_)) {
								GCalcMathExpression* _tmp57_;
								_tmp57_ = self->priv->current_parent;
								_tmp55_ = GCALC_IS_MATH_TERM (_tmp57_);
							} else {
								_tmp55_ = FALSE;
							}
							if (_tmp55_) {
								GCalcMathExpression* _tmp58_;
								_tmp58_ = self->priv->top_parent;
								_tmp54_ = GCALC_IS_MATH_POLYNOMIAL (_tmp58_);
							} else {
								_tmp54_ = FALSE;
							}
							if (_tmp54_) {
								GCalcMathExpression* _tmp59_;
								GCalcExpressionContainer* _tmp60_;
								GCalcExpressionContainer* _tmp61_;
								GCalcMathExpression* _tmp62_;
								GCalcMathExpression* _tmp63_;
								GCalcMathExpression* _tmp64_;
								GeeArrayList* _tmp65_;
								_tmp59_ = self->priv->current_parent;
								_tmp60_ = gcalc_math_expression_get_expressions (_tmp59_);
								_tmp61_ = _tmp60_;
								_tmp62_ = sfunc;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp62_);
								_tmp63_ = sfunc;
								_tmp64_ = _g_object_ref0 (_tmp63_);
								_g_object_unref0 (self->priv->current);
								self->priv->current = _tmp64_;
								_tmp65_ = self->priv->expected;
								gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp65_);
							} else {
								gboolean _tmp66_ = FALSE;
								GCalcMathExpression* _tmp67_;
								_tmp67_ = self->priv->current;
								if (GCALC_IS_MATH_TERM (_tmp67_)) {
									GCalcMathExpression* _tmp68_;
									_tmp68_ = self->priv->current_parent;
									_tmp66_ = GCALC_IS_MATH_POLYNOMIAL (_tmp68_);
								} else {
									_tmp66_ = FALSE;
								}
								if (_tmp66_) {
									GCalcMathExpression* _tmp69_;
									GCalcExpressionContainer* _tmp70_;
									GCalcExpressionContainer* _tmp71_;
									GCalcMathExpression* _tmp72_;
									GCalcMathExpression* _tmp73_;
									GCalcMathExpression* _tmp74_;
									GCalcMathExpression* _tmp75_;
									GCalcMathExpression* _tmp76_;
									GCalcMathExpression* _tmp77_;
									GCalcMathExpression* _tmp78_;
									GCalcMathExpression* _tmp79_;
									GCalcMathExpression* _tmp80_;
									GeeArrayList* _tmp81_;
									_tmp69_ = self->priv->current;
									_tmp70_ = gcalc_math_expression_get_expressions (_tmp69_);
									_tmp71_ = _tmp70_;
									_tmp72_ = sfunc;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp71_, _tmp72_);
									_tmp73_ = self->priv->current;
									_tmp74_ = _g_object_ref0 (_tmp73_);
									_g_object_unref0 (self->priv->current_parent);
									self->priv->current_parent = _tmp74_;
									_tmp75_ = sfunc;
									_tmp76_ = _g_object_ref0 (_tmp75_);
									_g_object_unref0 (self->priv->current);
									self->priv->current = _tmp76_;
									_tmp77_ = self->priv->current_parent;
									_tmp78_ = gcalc_math_expression_get_parent (_tmp77_);
									_tmp79_ = _tmp78_;
									_tmp80_ = _g_object_ref0 (_tmp79_);
									_g_object_unref0 (self->priv->top_parent);
									self->priv->top_parent = _tmp80_;
									_tmp81_ = self->priv->expected;
									gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp81_);
								}
							}
						}
					} else {
						gboolean _tmp82_ = FALSE;
						const gchar* _tmp83_;
						gchar* _tmp84_;
						gchar* _tmp85_;
						gboolean _tmp86_;
						_tmp83_ = n;
						_tmp84_ = g_utf8_strdown (_tmp83_, (gssize) -1);
						_tmp85_ = _tmp84_;
						_tmp86_ = g_strcmp0 (_tmp85_, "def") == 0;
						_g_free0 (_tmp85_);
						if (_tmp86_) {
							GCalcMathExpression* _tmp87_;
							_tmp87_ = self->priv->current;
							_tmp82_ = _tmp87_ == NULL;
						} else {
							_tmp82_ = FALSE;
						}
						if (_tmp82_) {
						} else {
							gboolean _tmp88_ = FALSE;
							const gchar* _tmp89_;
							gchar* _tmp90_;
							gchar* _tmp91_;
							gboolean _tmp92_;
							_tmp89_ = n;
							_tmp90_ = g_utf8_strdown (_tmp89_, (gssize) -1);
							_tmp91_ = _tmp90_;
							_tmp92_ = g_strcmp0 (_tmp91_, "def") == 0;
							_g_free0 (_tmp91_);
							if (_tmp92_) {
								GCalcMathExpression* _tmp93_;
								_tmp93_ = self->priv->current;
								_tmp88_ = GCALC_IS_MATH_FUNCTION (_tmp93_);
							} else {
								_tmp88_ = FALSE;
							}
							if (_tmp88_) {
								GError* _tmp94_;
								_tmp94_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected function definition expression"));
								_inner_error0_ = _tmp94_;
								g_propagate_error (error, _inner_error0_);
								_g_object_unref0 (sfunc);
								_g_free0 (n);
								return;
							} else {
								GCalcMathExpression* v = NULL;
								const gchar* _tmp95_;
								GCalcVariable* _tmp96_;
								GCalcMathExpression* _tmp97_;
								GCalcMathVariable* sv = NULL;
								const gchar* _tmp101_;
								GCalcMathVariable* _tmp102_;
								GCalcMathVariable* _tmp103_;
								GCalcMathVariable* _tmp104_;
								GCalcMathExpression* _tmp120_;
								_tmp95_ = n;
								_tmp96_ = gcalc_variable_new (_tmp95_);
								_tmp97_ = GCALC_IS_MATH_EXPRESSION (_tmp96_) ? ((GCalcMathExpression*) _tmp96_) : NULL;
								if (_tmp97_ == NULL) {
									_g_object_unref0 (_tmp96_);
								}
								v = _tmp97_;
								if (self->priv->enable_parameter) {
									const gchar* _tmp98_;
									GCalcParameter* _tmp99_;
									GCalcMathExpression* _tmp100_;
									_tmp98_ = n;
									_tmp99_ = gcalc_parameter_new (_tmp98_);
									_tmp100_ = GCALC_IS_MATH_EXPRESSION (_tmp99_) ? ((GCalcMathExpression*) _tmp99_) : NULL;
									if (_tmp100_ == NULL) {
										_g_object_unref0 (_tmp99_);
									}
									_g_object_unref0 (v);
									v = _tmp100_;
									self->priv->enable_parameter = FALSE;
								}
								_tmp101_ = n;
								_tmp102_ = gcalc_math_equation_manager_find_variable (eqman, _tmp101_);
								_tmp103_ = GCALC_IS_MATH_VARIABLE (_tmp102_) ? ((GCalcMathVariable*) _tmp102_) : NULL;
								if (_tmp103_ == NULL) {
									_g_object_unref0 (_tmp102_);
								}
								sv = _tmp103_;
								_tmp104_ = sv;
								if (_tmp104_ == NULL) {
									GCalcEquation* _tmp105_;
									GCalcExpressionHashMap* _tmp106_;
									GCalcExpressionHashMap* _tmp107_;
									const gchar* _tmp108_;
									GCalcMathExpression* _tmp109_;
									GCalcMathVariable* _tmp110_;
									GCalcMathVariable* _tmp111_;
									_tmp105_ = self->priv->eq;
									_tmp106_ = gcalc_math_equation_get_variables ((GCalcMathEquation*) _tmp105_);
									_tmp107_ = _tmp106_;
									_tmp108_ = n;
									_tmp109_ = gcalc_expression_hash_map_find_named (_tmp107_, _tmp108_);
									_tmp110_ = GCALC_IS_MATH_VARIABLE (_tmp109_) ? ((GCalcMathVariable*) _tmp109_) : NULL;
									if (_tmp110_ == NULL) {
										_g_object_unref0 (_tmp109_);
									}
									_g_object_unref0 (sv);
									sv = _tmp110_;
									_tmp111_ = sv;
									if (_tmp111_ == NULL) {
										GCalcEquation* _tmp112_;
										GCalcExpressionHashMap* _tmp113_;
										GCalcExpressionHashMap* _tmp114_;
										GCalcMathExpression* _tmp115_;
										_tmp112_ = self->priv->eq;
										_tmp113_ = gcalc_math_equation_get_variables ((GCalcMathEquation*) _tmp112_);
										_tmp114_ = _tmp113_;
										_tmp115_ = v;
										gcalc_expression_hash_map_add (_tmp114_, _tmp115_);
									} else {
										GCalcMathExpression* _tmp116_;
										GCalcMathVariable* _tmp117_;
										_tmp116_ = v;
										_tmp117_ = sv;
										gcalc_math_variable_set_bind (G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, GCALC_TYPE_MATH_VARIABLE, GCalcMathVariable), _tmp117_);
									}
								} else {
									GCalcMathExpression* _tmp118_;
									GCalcMathVariable* _tmp119_;
									_tmp118_ = v;
									_tmp119_ = sv;
									gcalc_math_variable_set_bind (G_TYPE_CHECK_INSTANCE_CAST (_tmp118_, GCALC_TYPE_MATH_VARIABLE, GCalcMathVariable), _tmp119_);
								}
								_tmp120_ = self->priv->current;
								if (_tmp120_ == NULL) {
									GCalcPolynomial* exp = NULL;
									GCalcPolynomial* _tmp121_;
									GCalcEquation* _tmp122_;
									GCalcExpressionContainer* _tmp123_;
									GCalcExpressionContainer* _tmp124_;
									GCalcPolynomial* _tmp125_;
									GCalcTerm* t = NULL;
									GCalcTerm* _tmp126_;
									GCalcPolynomial* _tmp127_;
									GCalcExpressionContainer* _tmp128_;
									GCalcExpressionContainer* _tmp129_;
									GCalcTerm* _tmp130_;
									GCalcTerm* _tmp131_;
									GCalcExpressionContainer* _tmp132_;
									GCalcExpressionContainer* _tmp133_;
									GCalcMathExpression* _tmp134_;
									GCalcMathExpression* _tmp135_;
									GCalcMathExpression* _tmp136_;
									GCalcMathExpression* _tmp137_;
									GCalcMathExpression* _tmp138_;
									GCalcMathExpression* _tmp139_;
									GCalcMathExpression* _tmp140_;
									GCalcMathExpression* _tmp141_;
									GCalcMathExpression* _tmp142_;
									GCalcMathExpression* _tmp143_;
									GCalcMathExpression* _tmp144_;
									GeeArrayList* _tmp145_;
									_tmp121_ = gcalc_polynomial_new ();
									exp = _tmp121_;
									_tmp122_ = self->priv->eq;
									_tmp123_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp122_);
									_tmp124_ = _tmp123_;
									_tmp125_ = exp;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp124_, (GCalcMathExpression*) _tmp125_);
									_tmp126_ = gcalc_term_new ();
									t = _tmp126_;
									_tmp127_ = exp;
									_tmp128_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp127_);
									_tmp129_ = _tmp128_;
									_tmp130_ = t;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp129_, (GCalcMathExpression*) _tmp130_);
									_tmp131_ = t;
									_tmp132_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp131_);
									_tmp133_ = _tmp132_;
									_tmp134_ = v;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp133_, _tmp134_);
									_tmp135_ = v;
									_tmp136_ = _g_object_ref0 (_tmp135_);
									_g_object_unref0 (self->priv->current);
									self->priv->current = _tmp136_;
									_tmp137_ = v;
									_tmp138_ = gcalc_math_expression_get_parent (_tmp137_);
									_tmp139_ = _tmp138_;
									_tmp140_ = _g_object_ref0 (_tmp139_);
									_g_object_unref0 (self->priv->current_parent);
									self->priv->current_parent = _tmp140_;
									_tmp141_ = self->priv->current_parent;
									_tmp142_ = gcalc_math_expression_get_parent (_tmp141_);
									_tmp143_ = _tmp142_;
									_tmp144_ = _g_object_ref0 (_tmp143_);
									_g_object_unref0 (self->priv->top_parent);
									self->priv->top_parent = _tmp144_;
									_tmp145_ = self->priv->expected;
									gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp145_);
									_g_object_unref0 (t);
									_g_object_unref0 (exp);
								} else {
									gboolean _tmp146_ = FALSE;
									gboolean _tmp147_ = FALSE;
									GCalcMathExpression* _tmp148_;
									_tmp148_ = self->priv->current;
									if (GCALC_IS_MATH_OPERATOR (_tmp148_)) {
										GCalcMathExpression* _tmp149_;
										_tmp149_ = self->priv->current_parent;
										_tmp147_ = GCALC_IS_MATH_TERM (_tmp149_);
									} else {
										_tmp147_ = FALSE;
									}
									if (_tmp147_) {
										GCalcMathExpression* _tmp150_;
										_tmp150_ = self->priv->top_parent;
										_tmp146_ = GCALC_IS_MATH_POLYNOMIAL (_tmp150_);
									} else {
										_tmp146_ = FALSE;
									}
									if (_tmp146_) {
										GCalcMathExpression* _tmp151_;
										GCalcExpressionContainer* _tmp152_;
										GCalcExpressionContainer* _tmp153_;
										GCalcMathExpression* _tmp154_;
										GCalcMathExpression* _tmp155_;
										GCalcMathExpression* _tmp156_;
										GeeArrayList* _tmp157_;
										_tmp151_ = self->priv->current_parent;
										_tmp152_ = gcalc_math_expression_get_expressions (_tmp151_);
										_tmp153_ = _tmp152_;
										_tmp154_ = v;
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp153_, _tmp154_);
										_tmp155_ = v;
										_tmp156_ = _g_object_ref0 (_tmp155_);
										_g_object_unref0 (self->priv->current);
										self->priv->current = _tmp156_;
										_tmp157_ = self->priv->expected;
										gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp157_);
									} else {
										GCalcMathExpression* _tmp158_;
										_tmp158_ = self->priv->current;
										if (GCALC_IS_MATH_TERM (_tmp158_)) {
											GCalcMathExpression* _tmp159_;
											GCalcExpressionContainer* _tmp160_;
											GCalcExpressionContainer* _tmp161_;
											GCalcMathExpression* _tmp162_;
											GCalcMathExpression* _tmp163_;
											GCalcMathExpression* _tmp164_;
											GCalcMathExpression* _tmp165_;
											GCalcMathExpression* _tmp166_;
											GCalcMathExpression* _tmp167_;
											GCalcMathExpression* _tmp168_;
											GCalcMathExpression* _tmp169_;
											GCalcMathExpression* _tmp170_;
											GCalcMathExpression* _tmp171_;
											GCalcMathExpression* _tmp172_;
											GeeArrayList* _tmp173_;
											_tmp159_ = self->priv->current;
											_tmp160_ = gcalc_math_expression_get_expressions (_tmp159_);
											_tmp161_ = _tmp160_;
											_tmp162_ = v;
											gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, _tmp162_);
											_tmp163_ = v;
											_tmp164_ = _g_object_ref0 (_tmp163_);
											_g_object_unref0 (self->priv->current);
											self->priv->current = _tmp164_;
											_tmp165_ = v;
											_tmp166_ = gcalc_math_expression_get_parent (_tmp165_);
											_tmp167_ = _tmp166_;
											_tmp168_ = _g_object_ref0 (_tmp167_);
											_g_object_unref0 (self->priv->current_parent);
											self->priv->current_parent = _tmp168_;
											_tmp169_ = self->priv->current_parent;
											_tmp170_ = gcalc_math_expression_get_parent (_tmp169_);
											_tmp171_ = _tmp170_;
											_tmp172_ = _g_object_ref0 (_tmp171_);
											_g_object_unref0 (self->priv->top_parent);
											self->priv->top_parent = _tmp172_;
											_tmp173_ = self->priv->expected;
											gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp173_);
										}
									}
								}
								_g_object_unref0 (sv);
								_g_object_unref0 (v);
							}
						}
					}
					_g_object_unref0 (sfunc);
				}
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL:
			case GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL:
			{
				gdouble res = 0.0;
				const gchar* _tmp174_;
				gdouble _tmp175_ = 0.0;
				gboolean _tmp176_;
				GCalcConstant* cexp = NULL;
				const gchar* _tmp178_;
				GCalcConstant* _tmp179_;
				GCalcConstant* _tmp180_;
				res = (gdouble) 0;
				_tmp174_ = n;
				_tmp176_ = double_try_parse (_tmp174_, &_tmp175_, NULL);
				res = _tmp175_;
				if (!_tmp176_) {
					GError* _tmp177_;
					_tmp177_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a constant"));
					_inner_error0_ = _tmp177_;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (n);
					return;
				}
				_tmp178_ = n;
				_tmp179_ = gcalc_constant_new_double (double_parse (_tmp178_));
				cexp = _tmp179_;
				_tmp180_ = cexp;
				gcalc_parser_add_constant (self, (GCalcMathConstant*) _tmp180_);
				_g_object_unref0 (cexp);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_STAR:
			{
				GCalcMultiply* op = NULL;
				GCalcMultiply* _tmp181_;
				GCalcMultiply* _tmp182_;
				GCalcEquation* _tmp183_;
				_tmp181_ = gcalc_multiply_new ();
				op = _tmp181_;
				_tmp182_ = op;
				_tmp183_ = self->priv->eq;
				gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp182_, _tmp183_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (op);
					_g_free0 (n);
					return;
				}
				_g_object_unref0 (op);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_PLUS:
			{
				GCalcPlus* opp = NULL;
				GCalcPlus* _tmp184_;
				GCalcPlus* _tmp185_;
				GCalcEquation* _tmp186_;
				_tmp184_ = gcalc_plus_new ();
				opp = _tmp184_;
				_tmp185_ = opp;
				_tmp186_ = self->priv->eq;
				gcalc_parser_process_operator (self, (GCalcMathOperator*) _tmp185_, _tmp186_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (opp);
					_g_free0 (n);
					return;
				}
				_g_object_unref0 (opp);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_DIV:
			{
				GCalcDivision* op = NULL;
				GCalcDivision* _tmp187_;
				GCalcDivision* _tmp188_;
				GCalcEquation* _tmp189_;
				_tmp187_ = gcalc_division_new ();
				op = _tmp187_;
				_tmp188_ = op;
				_tmp189_ = self->priv->eq;
				gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp188_, _tmp189_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (op);
					_g_free0 (n);
					return;
				}
				_g_object_unref0 (op);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_MINUS:
			{
				GCalcMinus* opp = NULL;
				GCalcMinus* _tmp190_;
				GCalcMinus* _tmp191_;
				GCalcEquation* _tmp192_;
				_tmp190_ = gcalc_minus_new ();
				opp = _tmp190_;
				_tmp191_ = opp;
				_tmp192_ = self->priv->eq;
				gcalc_parser_process_operator (self, (GCalcMathOperator*) _tmp191_, _tmp192_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (opp);
					_g_free0 (n);
					return;
				}
				_g_object_unref0 (opp);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_ASSIGN:
			{
				GCalcMathExpression* _tmp193_;
				_tmp193_ = self->priv->current;
				if (_tmp193_ == NULL) {
					GError* _tmp194_;
					_tmp194_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for an assignment"));
					_inner_error0_ = _tmp194_;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (n);
					return;
				} else {
					GCalcMathExpression* _tmp195_;
					_tmp195_ = self->priv->current;
					if (GCALC_IS_MATH_POLYNOMIAL (_tmp195_)) {
						GError* _tmp196_;
						_tmp196_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression: can't set a value to a polynomial"));
						_inner_error0_ = _tmp196_;
						g_propagate_error (error, _inner_error0_);
						_g_free0 (n);
						return;
					} else {
						GCalcMathExpression* _tmp197_;
						_tmp197_ = self->priv->current;
						if (GCALC_IS_MATH_VARIABLE (_tmp197_)) {
							gboolean removed = FALSE;
							GCalcMathExpression* _tmp198_;
							GCalcMathExpression* _tmp199_;
							GCalcMathExpression* _tmp200_;
							GCalcAssign* expa = NULL;
							GCalcAssign* _tmp233_;
							GCalcEquation* _tmp234_;
							GCalcExpressionContainer* _tmp235_;
							GCalcExpressionContainer* _tmp236_;
							GCalcAssign* _tmp237_;
							GCalcAssign* _tmp238_;
							GCalcExpressionContainer* _tmp239_;
							GCalcExpressionContainer* _tmp240_;
							GCalcMathExpression* _tmp241_;
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp242_;
							GCalcAssign* _tmp243_;
							GCalcExpressionContainer* _tmp244_;
							GCalcExpressionContainer* _tmp245_;
							GCalcPolynomial* _tmp246_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp247_;
							GCalcPolynomial* _tmp248_;
							GCalcExpressionContainer* _tmp249_;
							GCalcExpressionContainer* _tmp250_;
							GCalcTerm* _tmp251_;
							GCalcTerm* _tmp252_;
							GCalcMathExpression* _tmp253_;
							GCalcTerm* _tmp254_;
							GCalcMathExpression* _tmp255_;
							GCalcPolynomial* _tmp256_;
							GCalcMathExpression* _tmp257_;
							GeeArrayList* _tmp258_;
							removed = FALSE;
							_tmp198_ = self->priv->current;
							_tmp199_ = gcalc_math_expression_get_parent (_tmp198_);
							_tmp200_ = _tmp199_;
							if (_tmp200_ != NULL) {
								GCalcMathExpression* _tmp201_;
								GCalcMathExpression* _tmp202_;
								GCalcMathExpression* _tmp203_;
								_tmp201_ = self->priv->current;
								_tmp202_ = gcalc_math_expression_get_parent (_tmp201_);
								_tmp203_ = _tmp202_;
								if (GCALC_IS_MATH_TERM (_tmp203_)) {
									GCalcMathExpression* t = NULL;
									GCalcMathExpression* _tmp204_;
									GCalcMathExpression* _tmp205_;
									GCalcMathExpression* _tmp206_;
									GCalcMathExpression* _tmp207_;
									GCalcMathExpression* _tmp208_;
									GCalcMathExpression* _tmp209_;
									GCalcMathExpression* _tmp210_;
									_tmp204_ = self->priv->current;
									_tmp205_ = gcalc_math_expression_get_parent (_tmp204_);
									_tmp206_ = _tmp205_;
									_tmp207_ = _g_object_ref0 (_tmp206_);
									t = _tmp207_;
									_tmp208_ = t;
									_tmp209_ = gcalc_math_expression_get_parent (_tmp208_);
									_tmp210_ = _tmp209_;
									if (_tmp210_ != NULL) {
										GCalcMathExpression* _tmp211_;
										GCalcMathExpression* _tmp212_;
										GCalcMathExpression* _tmp213_;
										_tmp211_ = t;
										_tmp212_ = gcalc_math_expression_get_parent (_tmp211_);
										_tmp213_ = _tmp212_;
										if (GCALC_IS_MATH_POLYNOMIAL (_tmp213_)) {
											GCalcMathExpression* p = NULL;
											GCalcMathExpression* _tmp214_;
											GCalcMathExpression* _tmp215_;
											GCalcMathExpression* _tmp216_;
											GCalcMathExpression* _tmp217_;
											GCalcMathExpression* _tmp218_;
											GCalcMathExpression* _tmp219_;
											GCalcMathExpression* _tmp220_;
											_tmp214_ = t;
											_tmp215_ = gcalc_math_expression_get_parent (_tmp214_);
											_tmp216_ = _tmp215_;
											_tmp217_ = _g_object_ref0 (_tmp216_);
											p = _tmp217_;
											_tmp218_ = p;
											_tmp219_ = gcalc_math_expression_get_parent (_tmp218_);
											_tmp220_ = _tmp219_;
											if (_tmp220_ != NULL) {
												GCalcMathExpression* _tmp221_;
												GCalcMathExpression* _tmp222_;
												GCalcMathExpression* _tmp223_;
												_tmp221_ = p;
												_tmp222_ = gcalc_math_expression_get_parent (_tmp221_);
												_tmp223_ = _tmp222_;
												if (GCALC_IS_MATH_EQUATION (_tmp223_)) {
													GCalcEquation* _tmp224_;
													GCalcExpressionContainer* _tmp225_;
													GCalcExpressionContainer* _tmp226_;
													GCalcMathExpression* _tmp227_;
													GCalcMathExpression* _tmp228_;
													GCalcExpressionContainer* _tmp229_;
													GCalcExpressionContainer* _tmp230_;
													GCalcMathExpression* _tmp231_;
													_tmp224_ = self->priv->eq;
													_tmp225_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp224_);
													_tmp226_ = _tmp225_;
													_tmp227_ = p;
													gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp226_, _tmp227_);
													_tmp228_ = p;
													_tmp229_ = gcalc_math_expression_get_expressions (_tmp228_);
													_tmp230_ = _tmp229_;
													_tmp231_ = t;
													gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp230_, _tmp231_);
													removed = TRUE;
												}
											}
											_g_object_unref0 (p);
										}
									}
									_g_object_unref0 (t);
								}
							}
							if (!removed) {
								GError* _tmp232_;
								_tmp232_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_EXPRESSION_ERROR, _ ("Found an unexpected expression for an assignment. Assignment should be" \
" done on variables"));
								_inner_error0_ = _tmp232_;
								g_propagate_error (error, _inner_error0_);
								_g_free0 (n);
								return;
							}
							_tmp233_ = gcalc_assign_new ();
							expa = _tmp233_;
							_tmp234_ = self->priv->eq;
							_tmp235_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp234_);
							_tmp236_ = _tmp235_;
							_tmp237_ = expa;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp236_, (GCalcMathExpression*) _tmp237_);
							_tmp238_ = expa;
							_tmp239_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp238_);
							_tmp240_ = _tmp239_;
							_tmp241_ = self->priv->current;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp240_, _tmp241_);
							_tmp242_ = gcalc_polynomial_new ();
							exp = _tmp242_;
							_tmp243_ = expa;
							_tmp244_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp243_);
							_tmp245_ = _tmp244_;
							_tmp246_ = exp;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp245_, (GCalcMathExpression*) _tmp246_);
							_tmp247_ = gcalc_term_new ();
							t = _tmp247_;
							_tmp248_ = exp;
							_tmp249_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp248_);
							_tmp250_ = _tmp249_;
							_tmp251_ = t;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp250_, (GCalcMathExpression*) _tmp251_);
							_tmp252_ = t;
							_tmp253_ = _g_object_ref0 ((GCalcMathExpression*) _tmp252_);
							_g_object_unref0 (self->priv->current);
							self->priv->current = _tmp253_;
							_tmp254_ = t;
							_tmp255_ = _g_object_ref0 ((GCalcMathExpression*) _tmp254_);
							_g_object_unref0 (self->priv->current_parent);
							self->priv->current_parent = _tmp255_;
							_tmp256_ = exp;
							_tmp257_ = _g_object_ref0 ((GCalcMathExpression*) _tmp256_);
							_g_object_unref0 (self->priv->top_parent);
							self->priv->top_parent = _tmp257_;
							_tmp258_ = self->priv->expected;
							gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp258_);
							_g_object_unref0 (t);
							_g_object_unref0 (exp);
							_g_object_unref0 (expa);
						}
					}
				}
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS:
			{
				GCalcMathExpression* _tmp259_;
				_tmp259_ = self->priv->current;
				if (_tmp259_ == NULL) {
					GCalcPolynomial* exp = NULL;
					GCalcPolynomial* _tmp260_;
					GCalcEquation* _tmp261_;
					GCalcExpressionContainer* _tmp262_;
					GCalcExpressionContainer* _tmp263_;
					GCalcPolynomial* _tmp264_;
					GCalcTerm* t = NULL;
					GCalcTerm* _tmp265_;
					GCalcPolynomial* _tmp266_;
					GCalcExpressionContainer* _tmp267_;
					GCalcExpressionContainer* _tmp268_;
					GCalcTerm* _tmp269_;
					GCalcGroup* g = NULL;
					GCalcGroup* _tmp270_;
					GCalcTerm* _tmp271_;
					GCalcExpressionContainer* _tmp272_;
					GCalcExpressionContainer* _tmp273_;
					GCalcGroup* _tmp274_;
					GCalcPolynomial* exp2 = NULL;
					GCalcPolynomial* _tmp275_;
					GCalcTerm* t2 = NULL;
					GCalcTerm* _tmp276_;
					GCalcPolynomial* _tmp277_;
					GCalcExpressionContainer* _tmp278_;
					GCalcExpressionContainer* _tmp279_;
					GCalcTerm* _tmp280_;
					GCalcGroup* _tmp281_;
					GCalcExpressionContainer* _tmp282_;
					GCalcExpressionContainer* _tmp283_;
					GCalcPolynomial* _tmp284_;
					GCalcTerm* _tmp285_;
					GCalcMathExpression* _tmp286_;
					GCalcPolynomial* _tmp287_;
					GCalcMathExpression* _tmp288_;
					GCalcGroup* _tmp289_;
					GCalcMathExpression* _tmp290_;
					_tmp260_ = gcalc_polynomial_new ();
					exp = _tmp260_;
					_tmp261_ = self->priv->eq;
					_tmp262_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp261_);
					_tmp263_ = _tmp262_;
					_tmp264_ = exp;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp263_, (GCalcMathExpression*) _tmp264_);
					_tmp265_ = gcalc_term_new ();
					t = _tmp265_;
					_tmp266_ = exp;
					_tmp267_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp266_);
					_tmp268_ = _tmp267_;
					_tmp269_ = t;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp268_, (GCalcMathExpression*) _tmp269_);
					_tmp270_ = gcalc_group_new ();
					g = _tmp270_;
					_tmp271_ = t;
					_tmp272_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp271_);
					_tmp273_ = _tmp272_;
					_tmp274_ = g;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp273_, (GCalcMathExpression*) _tmp274_);
					_tmp275_ = gcalc_polynomial_new ();
					exp2 = _tmp275_;
					_tmp276_ = gcalc_term_new ();
					t2 = _tmp276_;
					_tmp277_ = exp2;
					_tmp278_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp277_);
					_tmp279_ = _tmp278_;
					_tmp280_ = t2;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp279_, (GCalcMathExpression*) _tmp280_);
					_tmp281_ = g;
					_tmp282_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp281_);
					_tmp283_ = _tmp282_;
					_tmp284_ = exp2;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp283_, (GCalcMathExpression*) _tmp284_);
					_tmp285_ = t2;
					_tmp286_ = _g_object_ref0 ((GCalcMathExpression*) _tmp285_);
					_g_object_unref0 (self->priv->current);
					self->priv->current = _tmp286_;
					_tmp287_ = exp2;
					_tmp288_ = _g_object_ref0 ((GCalcMathExpression*) _tmp287_);
					_g_object_unref0 (self->priv->current_parent);
					self->priv->current_parent = _tmp288_;
					_tmp289_ = g;
					_tmp290_ = _g_object_ref0 ((GCalcMathExpression*) _tmp289_);
					_g_object_unref0 (self->priv->top_parent);
					self->priv->top_parent = _tmp290_;
					_g_object_unref0 (t2);
					_g_object_unref0 (exp2);
					_g_object_unref0 (g);
					_g_object_unref0 (t);
					_g_object_unref0 (exp);
				} else {
					GCalcMathExpression* _tmp291_;
					_tmp291_ = self->priv->current;
					if (GCALC_IS_MATH_FUNCTION (_tmp291_)) {
						GCalcPolynomial* fexp = NULL;
						GCalcPolynomial* _tmp292_;
						GCalcTerm* t = NULL;
						GCalcTerm* _tmp293_;
						GCalcPolynomial* _tmp294_;
						GCalcExpressionContainer* _tmp295_;
						GCalcExpressionContainer* _tmp296_;
						GCalcTerm* _tmp297_;
						GCalcMathExpression* _tmp298_;
						GCalcExpressionContainer* _tmp299_;
						GCalcExpressionContainer* _tmp300_;
						GCalcPolynomial* _tmp301_;
						GCalcMathExpression* _tmp302_;
						GCalcMathExpression* _tmp303_;
						GCalcTerm* _tmp304_;
						GCalcMathExpression* _tmp305_;
						GCalcPolynomial* _tmp306_;
						GCalcMathExpression* _tmp307_;
						GeeArrayList* _tmp308_;
						_tmp292_ = gcalc_polynomial_new ();
						fexp = _tmp292_;
						_tmp293_ = gcalc_term_new ();
						t = _tmp293_;
						_tmp294_ = fexp;
						_tmp295_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp294_);
						_tmp296_ = _tmp295_;
						_tmp297_ = t;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp296_, (GCalcMathExpression*) _tmp297_);
						_tmp298_ = self->priv->current;
						_tmp299_ = gcalc_math_expression_get_expressions (_tmp298_);
						_tmp300_ = _tmp299_;
						_tmp301_ = fexp;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp300_, (GCalcMathExpression*) _tmp301_);
						_tmp302_ = self->priv->current;
						_tmp303_ = _g_object_ref0 (_tmp302_);
						_g_object_unref0 (self->priv->top_parent);
						self->priv->top_parent = _tmp303_;
						_tmp304_ = t;
						_tmp305_ = _g_object_ref0 ((GCalcMathExpression*) _tmp304_);
						_g_object_unref0 (self->priv->current);
						self->priv->current = _tmp305_;
						_tmp306_ = fexp;
						_tmp307_ = _g_object_ref0 ((GCalcMathExpression*) _tmp306_);
						_g_object_unref0 (self->priv->current_parent);
						self->priv->current_parent = _tmp307_;
						_tmp308_ = self->priv->expected;
						gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp308_);
						_g_object_unref0 (t);
						_g_object_unref0 (fexp);
					} else {
						gboolean _tmp309_ = FALSE;
						gboolean _tmp310_ = FALSE;
						GCalcMathExpression* _tmp311_;
						_tmp311_ = self->priv->current;
						if (GCALC_IS_MATH_OPERATOR (_tmp311_)) {
							GCalcMathExpression* _tmp312_;
							_tmp312_ = self->priv->current_parent;
							_tmp310_ = GCALC_IS_MATH_TERM (_tmp312_);
						} else {
							_tmp310_ = FALSE;
						}
						if (_tmp310_) {
							GCalcMathExpression* _tmp313_;
							_tmp313_ = self->priv->top_parent;
							_tmp309_ = GCALC_IS_MATH_POLYNOMIAL (_tmp313_);
						} else {
							_tmp309_ = FALSE;
						}
						if (_tmp309_) {
							GCalcGroup* g = NULL;
							GCalcGroup* _tmp314_;
							GCalcMathExpression* _tmp315_;
							GCalcExpressionContainer* _tmp316_;
							GCalcExpressionContainer* _tmp317_;
							GCalcGroup* _tmp318_;
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp319_;
							GCalcGroup* _tmp320_;
							GCalcExpressionContainer* _tmp321_;
							GCalcExpressionContainer* _tmp322_;
							GCalcPolynomial* _tmp323_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp324_;
							GCalcPolynomial* _tmp325_;
							GCalcExpressionContainer* _tmp326_;
							GCalcExpressionContainer* _tmp327_;
							GCalcTerm* _tmp328_;
							GCalcTerm* _tmp329_;
							GCalcMathExpression* _tmp330_;
							GCalcPolynomial* _tmp331_;
							GCalcMathExpression* _tmp332_;
							GCalcGroup* _tmp333_;
							GCalcMathExpression* _tmp334_;
							_tmp314_ = gcalc_group_new ();
							g = _tmp314_;
							_tmp315_ = self->priv->current_parent;
							_tmp316_ = gcalc_math_expression_get_expressions (_tmp315_);
							_tmp317_ = _tmp316_;
							_tmp318_ = g;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp317_, (GCalcMathExpression*) _tmp318_);
							_tmp319_ = gcalc_polynomial_new ();
							exp = _tmp319_;
							_tmp320_ = g;
							_tmp321_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp320_);
							_tmp322_ = _tmp321_;
							_tmp323_ = exp;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp322_, (GCalcMathExpression*) _tmp323_);
							_tmp324_ = gcalc_term_new ();
							t = _tmp324_;
							_tmp325_ = exp;
							_tmp326_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp325_);
							_tmp327_ = _tmp326_;
							_tmp328_ = t;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp327_, (GCalcMathExpression*) _tmp328_);
							_tmp329_ = t;
							_tmp330_ = _g_object_ref0 ((GCalcMathExpression*) _tmp329_);
							_g_object_unref0 (self->priv->current);
							self->priv->current = _tmp330_;
							_tmp331_ = exp;
							_tmp332_ = _g_object_ref0 ((GCalcMathExpression*) _tmp331_);
							_g_object_unref0 (self->priv->current_parent);
							self->priv->current_parent = _tmp332_;
							_tmp333_ = g;
							_tmp334_ = _g_object_ref0 ((GCalcMathExpression*) _tmp333_);
							_g_object_unref0 (self->priv->top_parent);
							self->priv->top_parent = _tmp334_;
							_g_object_unref0 (t);
							_g_object_unref0 (exp);
							_g_object_unref0 (g);
						}
					}
				}
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS:
			{
				GCalcMathExpression* _tmp335_;
				gboolean foundp = FALSE;
				GCalcMathExpression* par = NULL;
				GCalcMathExpression* _tmp337_;
				GCalcMathExpression* _tmp338_;
				_tmp335_ = self->priv->current;
				if (_tmp335_ == NULL) {
					GError* _tmp336_;
					_tmp336_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression while closing parenthesis"));
					_inner_error0_ = _tmp336_;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (n);
					return;
				}
				foundp = FALSE;
				_tmp337_ = self->priv->current;
				_tmp338_ = _g_object_ref0 (_tmp337_);
				par = _tmp338_;
				while (TRUE) {
					GCalcMathExpression* _tmp339_;
					GCalcMathExpression* _tmp340_;
					GCalcMathExpression* _tmp345_;
					GCalcMathExpression* _tmp350_;
					GCalcMathExpression* _tmp351_;
					GCalcMathExpression* _tmp352_;
					GCalcMathExpression* _tmp353_;
					_tmp339_ = par;
					if (!(_tmp339_ != NULL)) {
						break;
					}
					_tmp340_ = par;
					if (GCALC_IS_MATH_GROUP (_tmp340_)) {
						GCalcMathExpression* _tmp341_;
						gboolean _tmp342_;
						gboolean _tmp343_;
						_tmp341_ = par;
						_tmp342_ = gcalc_math_group_get_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp341_, GCALC_TYPE_MATH_GROUP, GCalcMathGroup));
						_tmp343_ = _tmp342_;
						if (!_tmp343_) {
							GCalcMathExpression* _tmp344_;
							foundp = TRUE;
							_tmp344_ = par;
							gcalc_math_group_set_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp344_, GCALC_TYPE_MATH_GROUP, GCalcMathGroup), TRUE);
							break;
						}
					}
					_tmp345_ = par;
					if (GCALC_IS_MATH_FUNCTION (_tmp345_)) {
						GCalcMathExpression* _tmp346_;
						gboolean _tmp347_;
						gboolean _tmp348_;
						_tmp346_ = par;
						_tmp347_ = gcalc_math_function_get_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp346_, GCALC_TYPE_MATH_FUNCTION, GCalcMathFunction));
						_tmp348_ = _tmp347_;
						if (!_tmp348_) {
							GCalcMathExpression* _tmp349_;
							foundp = TRUE;
							_tmp349_ = par;
							gcalc_math_function_set_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp349_, GCALC_TYPE_MATH_FUNCTION, GCalcMathFunction), TRUE);
							break;
						}
					}
					_tmp350_ = par;
					_tmp351_ = gcalc_math_expression_get_parent (_tmp350_);
					_tmp352_ = _tmp351_;
					_tmp353_ = _g_object_ref0 (_tmp352_);
					_g_object_unref0 (par);
					par = _tmp353_;
				}
				if (foundp) {
					GCalcMathExpression* _tmp354_;
					GCalcMathExpression* _tmp355_;
					GCalcMathExpression* _tmp356_;
					GCalcMathExpression* _tmp357_;
					GCalcMathExpression* _tmp358_;
					GCalcMathExpression* _tmp359_;
					GCalcMathExpression* _tmp360_;
					GCalcMathExpression* _tmp361_;
					GCalcMathExpression* _tmp362_;
					GCalcMathExpression* _tmp363_;
					_tmp354_ = par;
					_tmp355_ = _g_object_ref0 (_tmp354_);
					_g_object_unref0 (self->priv->current);
					self->priv->current = _tmp355_;
					_tmp356_ = par;
					_tmp357_ = gcalc_math_expression_get_parent (_tmp356_);
					_tmp358_ = _tmp357_;
					_tmp359_ = _g_object_ref0 (_tmp358_);
					_g_object_unref0 (self->priv->current_parent);
					self->priv->current_parent = _tmp359_;
					_tmp360_ = self->priv->current_parent;
					_tmp361_ = gcalc_math_expression_get_parent (_tmp360_);
					_tmp362_ = _tmp361_;
					_tmp363_ = _g_object_ref0 (_tmp362_);
					_g_object_unref0 (self->priv->top_parent);
					self->priv->top_parent = _tmp363_;
				}
				_g_object_unref0 (par);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_CARRET:
			{
				GCalcPow* op = NULL;
				GCalcPow* _tmp364_;
				GCalcMathExpression* _tmp365_;
				_tmp364_ = gcalc_pow_new ();
				op = _tmp364_;
				_tmp365_ = self->priv->current;
				if (_tmp365_ == NULL) {
					GError* _tmp366_;
					_tmp366_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression trying power expression"));
					_inner_error0_ = _tmp366_;
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (op);
					_g_free0 (n);
					return;
				} else {
					GCalcPow* _tmp367_;
					GCalcEquation* _tmp368_;
					_tmp367_ = op;
					_tmp368_ = self->priv->eq;
					gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp367_, _tmp368_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (op);
						_g_free0 (n);
						return;
					}
				}
				_g_object_unref0 (op);
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE:
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET:
			case GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE:
			case GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET:
			{
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL:
			{
				break;
			}
			case GCALC_PARSER_TOKEN_TYPE_OP_AND:
			case GCALC_PARSER_TOKEN_TYPE_OP_COALESCING:
			case GCALC_PARSER_TOKEN_TYPE_OP_DEC:
			case GCALC_PARSER_TOKEN_TYPE_OP_EQ:
			case GCALC_PARSER_TOKEN_TYPE_OP_GE:
			case GCALC_PARSER_TOKEN_TYPE_OP_GT:
			case GCALC_PARSER_TOKEN_TYPE_OP_INC:
			case GCALC_PARSER_TOKEN_TYPE_OP_LE:
			case GCALC_PARSER_TOKEN_TYPE_OP_LT:
			case GCALC_PARSER_TOKEN_TYPE_OP_NE:
			case GCALC_PARSER_TOKEN_TYPE_OP_NEG:
			case GCALC_PARSER_TOKEN_TYPE_OP_OR:
			case GCALC_PARSER_TOKEN_TYPE_OP_PTR:
			case GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT:
			case GCALC_PARSER_TOKEN_TYPE_SEMICOLON:
			case GCALC_PARSER_TOKEN_TYPE_TILDE:
			case GCALC_PARSER_TOKEN_TYPE_COLON:
			case GCALC_PARSER_TOKEN_TYPE_COMMA:
			case GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON:
			case GCALC_PARSER_TOKEN_TYPE_DOT:
			case GCALC_PARSER_TOKEN_TYPE_ELLIPSIS:
			case GCALC_PARSER_TOKEN_TYPE_INTERR:
			case GCALC_PARSER_TOKEN_TYPE_HASH:
			{
				GCalcParserTokenType _tmp369_;
				GEnumValue* _tmp370_;
				GError* _tmp371_;
				_tmp369_ = token;
				_tmp370_ = g_enum_get_value (g_type_class_ref (GCALC_PARSER_TYPE_TOKEN_TYPE), _tmp369_);
				_tmp371_ = g_error_new (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression: '%s'"), (_tmp370_ != NULL) ? _tmp370_->value_name : NULL);
				_inner_error0_ = _tmp371_;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (n);
				return;
			}
			case GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL:
			{
				self->priv->enable_parameter = TRUE;
				break;
			}
			default:
			break;
		}
		_g_free0 (n);
	}
	_tmp372_ = gcalc_math_equation_manager_get_equations (eqman);
	_tmp373_ = _tmp372_;
	_tmp374_ = self->priv->eq;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp373_, (GCalcMathExpression*) _tmp374_);
}

static void
gcalc_parser_process_operator (GCalcParser* self,
                               GCalcMathOperator* opp,
                               GCalcEquation* eq,
                               GError** error)
{
	GCalcMathExpression* _tmp0_;
	GCalcMathExpression* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (opp != NULL);
	g_return_if_fail (eq != NULL);
	_tmp0_ = self->priv->current;
	if (GCALC_IS_MATH_BINARY_OPERATOR (_tmp0_)) {
		GError* _tmp1_;
		_tmp1_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a plus operator"));
		_inner_error0_ = _tmp1_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp2_ = self->priv->current;
	if (_tmp2_ == NULL) {
		GCalcPolynomial* exp = NULL;
		GCalcPolynomial* _tmp3_;
		GCalcTerm* t = NULL;
		GCalcTerm* _tmp4_;
		GCalcTerm* _tmp5_;
		GCalcExpressionContainer* _tmp6_;
		GCalcExpressionContainer* _tmp7_;
		GCalcPolynomial* _tmp8_;
		GCalcExpressionContainer* _tmp9_;
		GCalcExpressionContainer* _tmp10_;
		GCalcTerm* _tmp11_;
		GCalcMathExpression* _tmp12_;
		GCalcTerm* _tmp13_;
		GCalcMathExpression* _tmp14_;
		GCalcPolynomial* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GCalcExpressionContainer* _tmp17_;
		GCalcExpressionContainer* _tmp18_;
		GCalcPolynomial* _tmp19_;
		GeeArrayList* _tmp20_;
		_tmp3_ = gcalc_polynomial_new ();
		exp = _tmp3_;
		_tmp4_ = gcalc_term_new ();
		t = _tmp4_;
		_tmp5_ = t;
		_tmp6_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp5_);
		_tmp7_ = _tmp6_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, (GCalcMathExpression*) opp);
		_tmp8_ = exp;
		_tmp9_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = t;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, (GCalcMathExpression*) _tmp11_);
		_tmp12_ = _g_object_ref0 ((GCalcMathExpression*) opp);
		_g_object_unref0 (self->priv->current);
		self->priv->current = _tmp12_;
		_tmp13_ = t;
		_tmp14_ = _g_object_ref0 ((GCalcMathExpression*) _tmp13_);
		_g_object_unref0 (self->priv->current_parent);
		self->priv->current_parent = _tmp14_;
		_tmp15_ = exp;
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) _tmp15_);
		_g_object_unref0 (self->priv->top_parent);
		self->priv->top_parent = _tmp16_;
		_tmp17_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
		_tmp18_ = _tmp17_;
		_tmp19_ = exp;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, (GCalcMathExpression*) _tmp19_);
		_tmp20_ = self->priv->expected;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp20_);
		_g_object_unref0 (t);
		_g_object_unref0 (exp);
	} else {
		gboolean _tmp21_ = FALSE;
		GCalcMathExpression* _tmp22_;
		_tmp22_ = self->priv->current_parent;
		if (GCALC_IS_MATH_POLYNOMIAL (_tmp22_)) {
			GCalcMathExpression* _tmp23_;
			_tmp23_ = self->priv->current;
			_tmp21_ = GCALC_IS_MATH_TERM (_tmp23_);
		} else {
			_tmp21_ = FALSE;
		}
		if (_tmp21_) {
			GCalcMathExpression* _tmp24_;
			GCalcExpressionContainer* _tmp25_;
			GCalcExpressionContainer* _tmp26_;
			GCalcMathExpression* _tmp27_;
			GCalcMathExpression* _tmp28_;
			GCalcMathExpression* _tmp29_;
			GCalcMathExpression* _tmp30_;
			GCalcMathExpression* _tmp31_;
			GeeArrayList* _tmp32_;
			_tmp24_ = self->priv->current;
			_tmp25_ = gcalc_math_expression_get_expressions (_tmp24_);
			_tmp26_ = _tmp25_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, (GCalcMathExpression*) opp);
			_tmp27_ = self->priv->current_parent;
			_tmp28_ = _g_object_ref0 (_tmp27_);
			_g_object_unref0 (self->priv->top_parent);
			self->priv->top_parent = _tmp28_;
			_tmp29_ = self->priv->current;
			_tmp30_ = _g_object_ref0 (_tmp29_);
			_g_object_unref0 (self->priv->current_parent);
			self->priv->current_parent = _tmp30_;
			_tmp31_ = _g_object_ref0 ((GCalcMathExpression*) opp);
			_g_object_unref0 (self->priv->current);
			self->priv->current = _tmp31_;
			_tmp32_ = self->priv->expected;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp32_);
		} else {
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			gboolean _tmp35_ = FALSE;
			GCalcMathExpression* _tmp36_;
			_tmp36_ = self->priv->current;
			if (GCALC_IS_MATH_CONSTANT (_tmp36_)) {
				_tmp35_ = TRUE;
			} else {
				GCalcMathExpression* _tmp37_;
				_tmp37_ = self->priv->current;
				_tmp35_ = GCALC_IS_MATH_VARIABLE (_tmp37_);
			}
			if (_tmp35_) {
				GCalcMathExpression* _tmp38_;
				_tmp38_ = self->priv->current_parent;
				_tmp34_ = GCALC_IS_MATH_TERM (_tmp38_);
			} else {
				_tmp34_ = FALSE;
			}
			if (_tmp34_) {
				GCalcMathExpression* _tmp39_;
				_tmp39_ = self->priv->top_parent;
				_tmp33_ = GCALC_IS_MATH_POLYNOMIAL (_tmp39_);
			} else {
				_tmp33_ = FALSE;
			}
			if (_tmp33_) {
				GCalcTerm* t = NULL;
				GCalcTerm* _tmp40_;
				GCalcTerm* _tmp41_;
				GCalcExpressionContainer* _tmp42_;
				GCalcExpressionContainer* _tmp43_;
				GCalcMathExpression* _tmp44_;
				GCalcExpressionContainer* _tmp45_;
				GCalcExpressionContainer* _tmp46_;
				GCalcTerm* _tmp47_;
				GCalcMathExpression* _tmp48_;
				GCalcTerm* _tmp49_;
				GCalcMathExpression* _tmp50_;
				GeeArrayList* _tmp51_;
				_tmp40_ = gcalc_term_new ();
				t = _tmp40_;
				_tmp41_ = t;
				_tmp42_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp41_);
				_tmp43_ = _tmp42_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, (GCalcMathExpression*) opp);
				_tmp44_ = self->priv->top_parent;
				_tmp45_ = gcalc_math_expression_get_expressions (_tmp44_);
				_tmp46_ = _tmp45_;
				_tmp47_ = t;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, (GCalcMathExpression*) _tmp47_);
				_tmp48_ = _g_object_ref0 ((GCalcMathExpression*) opp);
				_g_object_unref0 (self->priv->current);
				self->priv->current = _tmp48_;
				_tmp49_ = t;
				_tmp50_ = _g_object_ref0 ((GCalcMathExpression*) _tmp49_);
				_g_object_unref0 (self->priv->current_parent);
				self->priv->current_parent = _tmp50_;
				_tmp51_ = self->priv->expected;
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp51_);
				_g_object_unref0 (t);
			} else {
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				GCalcMathExpression* _tmp55_;
				_tmp55_ = self->priv->current;
				if (GCALC_IS_MATH_GROUP (_tmp55_)) {
					_tmp54_ = TRUE;
				} else {
					GCalcMathExpression* _tmp56_;
					_tmp56_ = self->priv->current;
					_tmp54_ = GCALC_IS_MATH_FUNCTION (_tmp56_);
				}
				if (_tmp54_) {
					GCalcMathExpression* _tmp57_;
					_tmp57_ = self->priv->current_parent;
					_tmp53_ = GCALC_IS_MATH_TERM (_tmp57_);
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					GCalcMathExpression* _tmp58_;
					_tmp58_ = self->priv->top_parent;
					_tmp52_ = GCALC_IS_MATH_POLYNOMIAL (_tmp58_);
				} else {
					_tmp52_ = FALSE;
				}
				if (_tmp52_) {
					GCalcTerm* t = NULL;
					GCalcTerm* _tmp59_;
					GCalcTerm* _tmp60_;
					GCalcExpressionContainer* _tmp61_;
					GCalcExpressionContainer* _tmp62_;
					GCalcMathExpression* _tmp63_;
					GCalcExpressionContainer* _tmp64_;
					GCalcExpressionContainer* _tmp65_;
					GCalcTerm* _tmp66_;
					GCalcMathExpression* _tmp67_;
					GCalcTerm* _tmp68_;
					GCalcMathExpression* _tmp69_;
					GCalcMathExpression* _tmp70_;
					GCalcMathExpression* _tmp71_;
					GCalcMathExpression* _tmp72_;
					GCalcMathExpression* _tmp73_;
					GeeArrayList* _tmp74_;
					_tmp59_ = gcalc_term_new ();
					t = _tmp59_;
					_tmp60_ = t;
					_tmp61_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp60_);
					_tmp62_ = _tmp61_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, (GCalcMathExpression*) opp);
					_tmp63_ = self->priv->top_parent;
					_tmp64_ = gcalc_math_expression_get_expressions (_tmp63_);
					_tmp65_ = _tmp64_;
					_tmp66_ = t;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp65_, (GCalcMathExpression*) _tmp66_);
					_tmp67_ = _g_object_ref0 ((GCalcMathExpression*) opp);
					_g_object_unref0 (self->priv->current);
					self->priv->current = _tmp67_;
					_tmp68_ = t;
					_tmp69_ = _g_object_ref0 ((GCalcMathExpression*) _tmp68_);
					_g_object_unref0 (self->priv->current_parent);
					self->priv->current_parent = _tmp69_;
					_tmp70_ = self->priv->current_parent;
					_tmp71_ = gcalc_math_expression_get_parent (_tmp70_);
					_tmp72_ = _tmp71_;
					_tmp73_ = _g_object_ref0 (_tmp72_);
					_g_object_unref0 (self->priv->top_parent);
					self->priv->top_parent = _tmp73_;
					_tmp74_ = self->priv->expected;
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp74_);
					_g_object_unref0 (t);
				} else {
					gboolean _tmp75_ = FALSE;
					GCalcMathExpression* _tmp76_;
					_tmp76_ = self->priv->current;
					if (GCALC_IS_MATH_VARIABLE (_tmp76_)) {
						GCalcMathExpression* _tmp77_;
						_tmp77_ = self->priv->current_parent;
						_tmp75_ = _tmp77_ == NULL;
					} else {
						_tmp75_ = FALSE;
					}
					if (_tmp75_) {
						GCalcPolynomial* exp = NULL;
						GCalcPolynomial* _tmp78_;
						GCalcExpressionContainer* _tmp79_;
						GCalcExpressionContainer* _tmp80_;
						GCalcPolynomial* _tmp81_;
						GCalcTerm* t = NULL;
						GCalcTerm* _tmp82_;
						GCalcPolynomial* _tmp83_;
						GCalcExpressionContainer* _tmp84_;
						GCalcExpressionContainer* _tmp85_;
						GCalcTerm* _tmp86_;
						GCalcTerm* _tmp87_;
						GCalcExpressionContainer* _tmp88_;
						GCalcExpressionContainer* _tmp89_;
						GCalcMathExpression* _tmp90_;
						GCalcTerm* t2 = NULL;
						GCalcTerm* _tmp91_;
						GCalcPolynomial* _tmp92_;
						GCalcExpressionContainer* _tmp93_;
						GCalcExpressionContainer* _tmp94_;
						GCalcTerm* _tmp95_;
						GCalcTerm* _tmp96_;
						GCalcExpressionContainer* _tmp97_;
						GCalcExpressionContainer* _tmp98_;
						GCalcMathExpression* _tmp99_;
						GCalcTerm* _tmp100_;
						GCalcMathExpression* _tmp101_;
						GCalcPolynomial* _tmp102_;
						GCalcMathExpression* _tmp103_;
						GeeArrayList* _tmp104_;
						_tmp78_ = gcalc_polynomial_new ();
						exp = _tmp78_;
						_tmp79_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
						_tmp80_ = _tmp79_;
						_tmp81_ = exp;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp80_, (GCalcMathExpression*) _tmp81_);
						_tmp82_ = gcalc_term_new ();
						t = _tmp82_;
						_tmp83_ = exp;
						_tmp84_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp83_);
						_tmp85_ = _tmp84_;
						_tmp86_ = t;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp85_, (GCalcMathExpression*) _tmp86_);
						_tmp87_ = t;
						_tmp88_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp87_);
						_tmp89_ = _tmp88_;
						_tmp90_ = self->priv->current;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp89_, _tmp90_);
						_tmp91_ = gcalc_term_new ();
						t2 = _tmp91_;
						_tmp92_ = exp;
						_tmp93_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp92_);
						_tmp94_ = _tmp93_;
						_tmp95_ = t2;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp94_, (GCalcMathExpression*) _tmp95_);
						_tmp96_ = t2;
						_tmp97_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp96_);
						_tmp98_ = _tmp97_;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, (GCalcMathExpression*) opp);
						_tmp99_ = _g_object_ref0 ((GCalcMathExpression*) opp);
						_g_object_unref0 (self->priv->current);
						self->priv->current = _tmp99_;
						_tmp100_ = t2;
						_tmp101_ = _g_object_ref0 ((GCalcMathExpression*) _tmp100_);
						_g_object_unref0 (self->priv->current_parent);
						self->priv->current_parent = _tmp101_;
						_tmp102_ = exp;
						_tmp103_ = _g_object_ref0 ((GCalcMathExpression*) _tmp102_);
						_g_object_unref0 (self->priv->top_parent);
						self->priv->top_parent = _tmp103_;
						_tmp104_ = self->priv->expected;
						gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp104_);
						_g_object_unref0 (t2);
						_g_object_unref0 (t);
						_g_object_unref0 (exp);
					}
				}
			}
		}
	}
}

static void
gcalc_parser_process_term_operator (GCalcParser* self,
                                    GCalcMathOperator* op,
                                    GCalcEquation* eq,
                                    GError** error)
{
	GCalcMathExpression* _tmp0_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GCalcMathExpression* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (eq != NULL);
	_tmp0_ = self->priv->current;
	if (GCALC_IS_MATH_OPERATOR (_tmp0_)) {
		GError* _tmp1_;
		_tmp1_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a multiply operator"));
		_inner_error0_ = _tmp1_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp7_ = self->priv->current;
	if (GCALC_IS_MATH_CONSTANT (_tmp7_)) {
		_tmp6_ = TRUE;
	} else {
		GCalcMathExpression* _tmp8_;
		_tmp8_ = self->priv->current;
		_tmp6_ = GCALC_IS_MATH_VARIABLE (_tmp8_);
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		GCalcMathExpression* _tmp9_;
		_tmp9_ = self->priv->current;
		_tmp5_ = GCALC_IS_MATH_GROUP (_tmp9_);
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		GCalcMathExpression* _tmp10_;
		_tmp10_ = self->priv->current;
		_tmp4_ = GCALC_IS_MATH_FUNCTION (_tmp10_);
	}
	if (_tmp4_) {
		GCalcMathExpression* _tmp11_;
		_tmp11_ = self->priv->current_parent;
		_tmp3_ = GCALC_IS_MATH_TERM (_tmp11_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GCalcMathExpression* _tmp12_;
		_tmp12_ = self->priv->top_parent;
		_tmp2_ = GCALC_IS_MATH_POLYNOMIAL (_tmp12_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GCalcMathExpression* _tmp13_;
		GCalcExpressionContainer* _tmp14_;
		GCalcExpressionContainer* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GeeArrayList* _tmp17_;
		_tmp13_ = self->priv->current_parent;
		_tmp14_ = gcalc_math_expression_get_expressions (_tmp13_);
		_tmp15_ = _tmp14_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, (GCalcMathExpression*) op);
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) op);
		_g_object_unref0 (self->priv->current);
		self->priv->current = _tmp16_;
		_tmp17_ = self->priv->expected;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp17_);
	} else {
		gboolean _tmp18_ = FALSE;
		GCalcMathExpression* _tmp19_;
		_tmp19_ = self->priv->current;
		if (GCALC_IS_MATH_VARIABLE (_tmp19_)) {
			GCalcMathExpression* _tmp20_;
			_tmp20_ = self->priv->current_parent;
			_tmp18_ = _tmp20_ == NULL;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			GCalcPolynomial* exp = NULL;
			GCalcPolynomial* _tmp21_;
			GCalcExpressionContainer* _tmp22_;
			GCalcExpressionContainer* _tmp23_;
			GCalcPolynomial* _tmp24_;
			GCalcTerm* t = NULL;
			GCalcTerm* _tmp25_;
			GCalcPolynomial* _tmp26_;
			GCalcExpressionContainer* _tmp27_;
			GCalcExpressionContainer* _tmp28_;
			GCalcTerm* _tmp29_;
			GCalcTerm* _tmp30_;
			GCalcExpressionContainer* _tmp31_;
			GCalcExpressionContainer* _tmp32_;
			GCalcMathExpression* _tmp33_;
			GCalcTerm* _tmp34_;
			GCalcExpressionContainer* _tmp35_;
			GCalcExpressionContainer* _tmp36_;
			GCalcMathExpression* _tmp37_;
			GCalcTerm* _tmp38_;
			GCalcMathExpression* _tmp39_;
			GCalcPolynomial* _tmp40_;
			GCalcMathExpression* _tmp41_;
			GeeArrayList* _tmp42_;
			_tmp21_ = gcalc_polynomial_new ();
			exp = _tmp21_;
			_tmp22_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
			_tmp23_ = _tmp22_;
			_tmp24_ = exp;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, (GCalcMathExpression*) _tmp24_);
			_tmp25_ = gcalc_term_new ();
			t = _tmp25_;
			_tmp26_ = exp;
			_tmp27_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp26_);
			_tmp28_ = _tmp27_;
			_tmp29_ = t;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, (GCalcMathExpression*) _tmp29_);
			_tmp30_ = t;
			_tmp31_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = self->priv->current;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
			_tmp34_ = t;
			_tmp35_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp34_);
			_tmp36_ = _tmp35_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (GCalcMathExpression*) op);
			_tmp37_ = _g_object_ref0 ((GCalcMathExpression*) op);
			_g_object_unref0 (self->priv->current);
			self->priv->current = _tmp37_;
			_tmp38_ = t;
			_tmp39_ = _g_object_ref0 ((GCalcMathExpression*) _tmp38_);
			_g_object_unref0 (self->priv->current_parent);
			self->priv->current_parent = _tmp39_;
			_tmp40_ = exp;
			_tmp41_ = _g_object_ref0 ((GCalcMathExpression*) _tmp40_);
			_g_object_unref0 (self->priv->top_parent);
			self->priv->top_parent = _tmp41_;
			_tmp42_ = self->priv->expected;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp42_);
			_g_object_unref0 (t);
			_g_object_unref0 (exp);
		}
	}
}

static void
gcalc_parser_add_constant (GCalcParser* self,
                           GCalcMathConstant* c)
{
	GCalcMathExpression* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->current;
	if (_tmp0_ == NULL) {
		GCalcPolynomial* exp = NULL;
		GCalcPolynomial* _tmp1_;
		GCalcEquation* _tmp2_;
		GCalcExpressionContainer* _tmp3_;
		GCalcExpressionContainer* _tmp4_;
		GCalcPolynomial* _tmp5_;
		GCalcTerm* t = NULL;
		GCalcTerm* _tmp6_;
		GCalcPolynomial* _tmp7_;
		GCalcExpressionContainer* _tmp8_;
		GCalcExpressionContainer* _tmp9_;
		GCalcTerm* _tmp10_;
		GCalcTerm* _tmp11_;
		GCalcExpressionContainer* _tmp12_;
		GCalcExpressionContainer* _tmp13_;
		GCalcMathExpression* _tmp14_;
		GCalcTerm* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GCalcPolynomial* _tmp17_;
		GCalcMathExpression* _tmp18_;
		_tmp1_ = gcalc_polynomial_new ();
		exp = _tmp1_;
		_tmp2_ = self->priv->eq;
		_tmp3_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = exp;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, (GCalcMathExpression*) _tmp5_);
		_tmp6_ = gcalc_term_new ();
		t = _tmp6_;
		_tmp7_ = exp;
		_tmp8_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = t;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (GCalcMathExpression*) _tmp10_);
		_tmp11_ = t;
		_tmp12_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp11_);
		_tmp13_ = _tmp12_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, (GCalcMathExpression*) c);
		_tmp14_ = _g_object_ref0 ((GCalcMathExpression*) c);
		_g_object_unref0 (self->priv->current);
		self->priv->current = _tmp14_;
		_tmp15_ = t;
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) _tmp15_);
		_g_object_unref0 (self->priv->current_parent);
		self->priv->current_parent = _tmp16_;
		_tmp17_ = exp;
		_tmp18_ = _g_object_ref0 ((GCalcMathExpression*) _tmp17_);
		_g_object_unref0 (self->priv->top_parent);
		self->priv->top_parent = _tmp18_;
		_g_object_unref0 (t);
		_g_object_unref0 (exp);
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		GCalcMathExpression* _tmp22_;
		_tmp22_ = self->priv->current;
		if (GCALC_IS_MATH_OPERATOR (_tmp22_)) {
			_tmp21_ = TRUE;
		} else {
			GCalcMathExpression* _tmp23_;
			_tmp23_ = self->priv->current;
			_tmp21_ = GCALC_IS_MATH_TERM (_tmp23_);
		}
		if (_tmp21_) {
			GCalcMathExpression* _tmp24_;
			_tmp24_ = self->priv->current_parent;
			_tmp20_ = GCALC_IS_MATH_TERM (_tmp24_);
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			GCalcMathExpression* _tmp25_;
			_tmp25_ = self->priv->top_parent;
			_tmp19_ = GCALC_IS_MATH_POLYNOMIAL (_tmp25_);
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			GCalcMathExpression* _tmp26_;
			GCalcExpressionContainer* _tmp27_;
			GCalcExpressionContainer* _tmp28_;
			GeeArrayList* _tmp29_;
			GCalcMathExpression* _tmp30_;
			_tmp26_ = self->priv->current_parent;
			_tmp27_ = gcalc_math_expression_get_expressions (_tmp26_);
			_tmp28_ = _tmp27_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, (GCalcMathExpression*) c);
			_tmp29_ = self->priv->expected;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp29_);
			_tmp30_ = _g_object_ref0 ((GCalcMathExpression*) c);
			_g_object_unref0 (self->priv->current);
			self->priv->current = _tmp30_;
		} else {
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			GCalcMathExpression* _tmp33_;
			_tmp33_ = self->priv->current;
			if (GCALC_IS_MATH_TERM (_tmp33_)) {
				GCalcMathExpression* _tmp34_;
				_tmp34_ = self->priv->current_parent;
				_tmp32_ = GCALC_IS_MATH_POLYNOMIAL (_tmp34_);
			} else {
				_tmp32_ = FALSE;
			}
			if (_tmp32_) {
				gboolean _tmp35_ = FALSE;
				GCalcMathExpression* _tmp36_;
				_tmp36_ = self->priv->top_parent;
				if (GCALC_IS_MATH_GROUP (_tmp36_)) {
					_tmp35_ = TRUE;
				} else {
					GCalcMathExpression* _tmp37_;
					_tmp37_ = self->priv->top_parent;
					_tmp35_ = GCALC_IS_MATH_FUNCTION (_tmp37_);
				}
				_tmp31_ = _tmp35_;
			} else {
				_tmp31_ = FALSE;
			}
			if (_tmp31_) {
				GCalcMathExpression* _tmp38_;
				GCalcExpressionContainer* _tmp39_;
				GCalcExpressionContainer* _tmp40_;
				GCalcMathExpression* _tmp41_;
				GCalcMathExpression* _tmp42_;
				GCalcMathExpression* _tmp43_;
				GCalcMathExpression* _tmp44_;
				GCalcMathExpression* _tmp45_;
				GeeArrayList* _tmp46_;
				_tmp38_ = self->priv->current;
				_tmp39_ = gcalc_math_expression_get_expressions (_tmp38_);
				_tmp40_ = _tmp39_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, (GCalcMathExpression*) c);
				_tmp41_ = self->priv->current_parent;
				_tmp42_ = _g_object_ref0 (_tmp41_);
				_g_object_unref0 (self->priv->top_parent);
				self->priv->top_parent = _tmp42_;
				_tmp43_ = self->priv->current;
				_tmp44_ = _g_object_ref0 (_tmp43_);
				_g_object_unref0 (self->priv->current_parent);
				self->priv->current_parent = _tmp44_;
				_tmp45_ = _g_object_ref0 ((GCalcMathExpression*) c);
				_g_object_unref0 (self->priv->current);
				self->priv->current = _tmp45_;
				_tmp46_ = self->priv->expected;
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp46_);
			}
		}
	}
}

/**
   * Reads a token at a given position
   */
GCalcParserTokenType
gcalc_parser_read_token (GCalcParser* self)
{
	GTokenType t = 0;
	GScanner* _tmp0_;
	GTokenType _tmp1_;
	GCalcParserTokenType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->scanner;
	t = g_scanner_get_next_token (_tmp0_);
	_tmp1_ = t;
	switch (_tmp1_) {
		case G_TOKEN_IDENTIFIER:
		{
			result = GCALC_PARSER_TOKEN_TYPE_IDENTIFIER;
			return result;
		}
		case G_TOKEN_INT:
		{
			result = GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL;
			return result;
		}
		case G_TOKEN_FLOAT:
		{
			result = GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL;
			return result;
		}
		case G_TOKEN_STRING:
		{
			result = GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL;
			return result;
		}
		case G_TOKEN_EOF:
		{
			result = GCALC_PARSER_TOKEN_TYPE_EOF;
			return result;
		}
		case G_TOKEN_CHAR:
		{
			guchar v = '\0';
			GScanner* _tmp2_;
			_tmp2_ = self->priv->scanner;
			v = g_scanner_cur_value (_tmp2_).v_char;
			if (g_ascii_isalpha ((gchar) v)) {
				result = GCALC_PARSER_TOKEN_TYPE_IDENTIFIER;
				return result;
			}
			switch (v) {
				case '*':
				{
					result = GCALC_PARSER_TOKEN_TYPE_STAR;
					return result;
				}
				case '/':
				{
					result = GCALC_PARSER_TOKEN_TYPE_DIV;
					return result;
				}
				case '+':
				{
					result = GCALC_PARSER_TOKEN_TYPE_PLUS;
					return result;
				}
				case '-':
				{
					result = GCALC_PARSER_TOKEN_TYPE_MINUS;
					return result;
				}
				case '^':
				{
					result = GCALC_PARSER_TOKEN_TYPE_CARRET;
					return result;
				}
				case ')':
				{
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS;
					return result;
				}
				case '(':
				{
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS;
					return result;
				}
				case '=':
				{
					result = GCALC_PARSER_TOKEN_TYPE_ASSIGN;
					return result;
				}
				case '{':
				{
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE;
					return result;
				}
				case '}':
				{
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE;
					return result;
				}
				case '[':
				{
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET;
					return result;
				}
				case ']':
				{
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET;
					return result;
				}
				case '$':
				{
					result = GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL;
					return result;
				}
				default:
				break;
			}
			break;
		}
		default:
		break;
	}
	result = GCALC_PARSER_TOKEN_TYPE_NONE;
	return result;
}

/**
   * Creates a string representation of the current {@link TokenType}
   */
gchar*
gcalc_parser_token_to_string (GCalcParser* self)
{
	GTokenType t = 0;
	GScanner* _tmp0_;
	GTokenType _tmp1_;
	gchar* _tmp19_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->scanner;
	t = g_scanner_cur_token (_tmp0_);
	_tmp1_ = t;
	switch (_tmp1_) {
		case G_TOKEN_IDENTIFIER:
		{
			GScanner* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			_tmp2_ = self->priv->scanner;
			_tmp3_ = g_scanner_cur_value (_tmp2_).v_identifier;
			_tmp4_ = g_strdup (_tmp3_);
			result = _tmp4_;
			return result;
		}
		case G_TOKEN_INT:
		{
			GScanner* _tmp5_;
			gchar* _tmp6_;
			_tmp5_ = self->priv->scanner;
			_tmp6_ = g_strdup_printf ("%lu", g_scanner_cur_value (_tmp5_).v_int);
			result = _tmp6_;
			return result;
		}
		case G_TOKEN_FLOAT:
		{
			GScanner* _tmp7_;
			gchar* _tmp8_;
			_tmp7_ = self->priv->scanner;
			_tmp8_ = g_strdup_printf ("%g", g_scanner_cur_value (_tmp7_).v_float);
			result = _tmp8_;
			return result;
		}
		case G_TOKEN_EOF:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("");
			result = _tmp9_;
			return result;
		}
		case G_TOKEN_CHAR:
		{
			GString* str = NULL;
			GString* _tmp10_;
			GString* _tmp11_;
			GScanner* _tmp12_;
			GString* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			_tmp10_ = g_string_new ("");
			str = _tmp10_;
			_tmp11_ = str;
			_tmp12_ = self->priv->scanner;
			g_string_append_c (_tmp11_, (gchar) g_scanner_cur_value (_tmp12_).v_char);
			_tmp13_ = str;
			_tmp14_ = _tmp13_->str;
			_tmp15_ = g_strdup (_tmp14_);
			result = _tmp15_;
			_g_string_free0 (str);
			return result;
		}
		case G_TOKEN_STRING:
		{
			GScanner* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp16_ = self->priv->scanner;
			_tmp17_ = g_scanner_cur_value (_tmp16_).v_string;
			_tmp18_ = g_strdup (_tmp17_);
			result = _tmp18_;
			return result;
		}
		default:
		break;
	}
	_tmp19_ = g_strdup ("");
	result = _tmp19_;
	return result;
}

GCalcParser*
gcalc_parser_construct (GType object_type)
{
	GCalcParser * self = NULL;
	self = (GCalcParser*) g_object_new (object_type, NULL);
	return self;
}

GCalcParser*
gcalc_parser_new (void)
{
	return gcalc_parser_construct (GCALC_TYPE_PARSER);
}

static GObject *
gcalc_parser_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GCalcParser * self;
	GScanner* _tmp0_;
	GScanner* _tmp1_;
	GScanner* _tmp2_;
	GScannerConfig* _tmp3_;
	GScanner* _tmp4_;
	GScannerConfig* _tmp5_;
	GScanner* _tmp6_;
	GScannerConfig* _tmp7_;
	GScanner* _tmp8_;
	GScannerConfig* _tmp9_;
	GScanner* _tmp10_;
	GScannerConfig* _tmp11_;
	GScanner* _tmp12_;
	GScannerConfig* _tmp13_;
	GScanner* _tmp14_;
	GScannerConfig* _tmp15_;
	GScanner* _tmp16_;
	GScannerConfig* _tmp17_;
	GScanner* _tmp18_;
	GScannerConfig* _tmp19_;
	GScanner* _tmp20_;
	GScannerConfig* _tmp21_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (gcalc_parser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_PARSER, GCalcParser);
	_tmp0_ = g_scanner_new (NULL);
	_g_scanner_destroy0 (self->priv->scanner);
	self->priv->scanner = _tmp0_;
	_tmp1_ = self->priv->scanner;
	_tmp1_->input_name = "GCalc";
	_tmp2_ = self->priv->scanner;
	_tmp3_ = _tmp2_->config;
	(*_tmp3_).cpair_comment_single = "\n";
	_tmp4_ = self->priv->scanner;
	_tmp5_ = _tmp4_->config;
	(*_tmp5_).skip_comment_multi = FALSE;
	_tmp6_ = self->priv->scanner;
	_tmp7_ = _tmp6_->config;
	(*_tmp7_).skip_comment_single = FALSE;
	_tmp8_ = self->priv->scanner;
	_tmp9_ = _tmp8_->config;
	(*_tmp9_).char_2_token = FALSE;
	_tmp10_ = self->priv->scanner;
	_tmp11_ = _tmp10_->config;
	(*_tmp11_).scan_binary = FALSE;
	_tmp12_ = self->priv->scanner;
	_tmp13_ = _tmp12_->config;
	(*_tmp13_).scan_octal = FALSE;
	_tmp14_ = self->priv->scanner;
	_tmp15_ = _tmp14_->config;
	(*_tmp15_).scan_float = FALSE;
	_tmp16_ = self->priv->scanner;
	_tmp17_ = _tmp16_->config;
	(*_tmp17_).scan_hex = FALSE;
	_tmp18_ = self->priv->scanner;
	_tmp19_ = _tmp18_->config;
	(*_tmp19_).scan_hex_dollar = FALSE;
	_tmp20_ = self->priv->scanner;
	_tmp21_ = _tmp20_->config;
	(*_tmp21_).numbers_2_int = FALSE;
	{
		GRegex* _tmp22_ = NULL;
		GRegex* _tmp23_;
		GRegex* _tmp24_;
		_tmp23_ = g_regex_new ("^i\\d", G_REGEX_ANCHORED, G_REGEX_MATCH_ANCHORED, &_inner_error0_);
		_tmp22_ = _tmp23_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp24_ = _tmp22_;
		_tmp22_ = NULL;
		_g_regex_unref0 (self->priv->rg);
		self->priv->rg = _tmp24_;
		_g_regex_unref0 (_tmp22_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp25_ = e;
		_tmp26_ = _tmp25_->message;
		g_message ("gcalc-parser.vala:51: Error on compile regular expression: %s", _tmp26_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	return obj;
}

static void
gcalc_parser_class_init (GCalcParserClass * klass,
                         gpointer klass_data)
{
	gcalc_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GCalcParser_private_offset);
	G_OBJECT_CLASS (klass)->constructor = gcalc_parser_constructor;
	G_OBJECT_CLASS (klass)->finalize = gcalc_parser_finalize;
}

static void
gcalc_parser_instance_init (GCalcParser * self,
                            gpointer klass)
{
	GeeArrayList* _tmp0_;
	self->priv = gcalc_parser_get_instance_private (self);
	self->priv->current = NULL;
	self->priv->current_parent = NULL;
	self->priv->top_parent = NULL;
	self->priv->eq = NULL;
	self->priv->enable_parameter = FALSE;
	_tmp0_ = gee_array_list_new (GCALC_PARSER_TYPE_TOKEN_TYPE, NULL, NULL, NULL, NULL, NULL);
	self->priv->expected = _tmp0_;
}

static void
gcalc_parser_finalize (GObject * obj)
{
	GCalcParser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_PARSER, GCalcParser);
	_g_object_unref0 (self->priv->current);
	_g_object_unref0 (self->priv->current_parent);
	_g_object_unref0 (self->priv->top_parent);
	_g_object_unref0 (self->priv->eq);
	_g_regex_unref0 (self->priv->rg);
	_g_object_unref0 (self->priv->expected);
	_g_scanner_destroy0 (self->priv->scanner);
	G_OBJECT_CLASS (gcalc_parser_parent_class)->finalize (obj);
}

/**
 * Takes a string an create a tree of {@link MathExpression} objects representing
 * a math equation.
 */
static GType
gcalc_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GCalcParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gcalc_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GCalcParser), 0, (GInstanceInitFunc) gcalc_parser_instance_init, NULL };
	GType gcalc_parser_type_id;
	gcalc_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "GCalcParser", &g_define_type_info, 0);
	GCalcParser_private_offset = g_type_add_instance_private (gcalc_parser_type_id, sizeof (GCalcParserPrivate));
	return gcalc_parser_type_id;
}

GType
gcalc_parser_get_type (void)
{
	static volatile gsize gcalc_parser_type_id__volatile = 0;
	if (g_once_init_enter (&gcalc_parser_type_id__volatile)) {
		GType gcalc_parser_type_id;
		gcalc_parser_type_id = gcalc_parser_get_type_once ();
		g_once_init_leave (&gcalc_parser_type_id__volatile, gcalc_parser_type_id);
	}
	return gcalc_parser_type_id__volatile;
}

GQuark
gcalc_parser_error_quark (void)
{
	return g_quark_from_static_string ("gcalc-parser-error-quark");
}

